#! /usr/bin/env python3

import os, re, sys

meine_interpreten = set([])
meine_alben = set(['Sing meinen Song - Das Tauschkonzert, Vol. 5 (Deluxe Edition)',
	'Leichtes Gepäck', 'Leichtes Gepäck - Live in Dresden', 'Himmel Auf', 
	'Nichts Passiert', 'Verschwende deine Zeit', 
	'Zimmer mit Blick', 'Immer in Bewegung - Live', 'Revolverheld',
	'Immer in Bewegung', 'MTV Unplugged in drei Akten',
	'Zeit bleibt Zeit', 'Nackt'])

textFile = open("/Users/wolfgang/Music/iTunes/iTunes Music Library.xml", encoding='utf-8')
lines = textFile.readlines()

sql = ''

# Album-Hash, Interpreten-Hash
alben = {}
albencount = 0;

interpreten = {}
interpretencount = 0;

albeninterpreten = {}
albenerscheinungsjahre = {}

# Durchlaufe alle Zeilen
for line in lines:

	# Beginn eines neuen Datensatzes
	mo = re.search("<dict>",line)
	if (mo!=None):
		titelid = ''
		interpret = ''
		titel = ''
		titelnr = ''
		album = ''
		albuminterpret = ''
		compilation = ''
		bewertung = ''
		erscheinungsjahr = ''
		medientyp = ''
		dauer = ''

	# Isoliere nach und nach die Attribute
	mo = re.search("<key>Name</key><string>(.*)</string>",line)
	if (mo!=None):
		titel = mo.group(1)
		titel = titel.replace('"','')
		titel = titel.replace('&#38;','&')

	mo = re.search("<key>Artist</key><string>(.*)</string>",line)
	if (mo!=None):
		interpret = mo.group(1)
		interpret = interpret.replace('&#38;','&')

	mo = re.search("<key>Album</key><string>(.*)</string>",line)
	if (mo!=None):
		album = mo.group(1)
		album = album.replace('&#38;','&')

	mo = re.search("<key>Album Artist</key><string>(.*)</string>",line)
	if (mo!=None):
		albuminterpret = mo.group(1)
		albuminterpret = albuminterpret.replace('&#38;','&')		

	mo = re.search("<key>Compilation</key><true/>",line)
	if (mo!=None):
		compilation = 'Sampler'

	mo = re.search("<key>Kind</key><string>.*AAC.*</string>",line)
	if (mo!=None):
		medientyp = 'AAC'

	mo = re.search("<key>Track Number</key><string>(.*)</string>",line)
	if (mo!=None):
		titelnr = mo.group(1)

	mo = re.search("<key>Year</key><integer>(.*)</integer>",line)
	if (mo!=None):
		erscheinungsjahr = int(mo.group(1))

	mo = re.search("<key>Rating</key><integer>(.*)</integer>",line)
	if (mo!=None):
		bewertung = str(int(int(mo.group(1)) / 20))

	mo = re.search("<key>Total Time</key><integer>(.*)</integer>",line)
	if (mo!=None):
		dauer = str(int(int(mo.group(1)) / 1000))

	mo = re.search("<key>Track ID</key><integer>(.*)</integer>",line)
	if (mo!=None):
		titelid = mo.group(1)

	# Ende eines Datensatzes
	mo = re.search("</dict>",line)
	if (mo!=None):

		# Sind die wesentlichen Informationen da?
		if ((titel!='') and (interpret!='') and (album!='') and (albuminterpret!='') and (medientyp!='')):
			if ((interpret in meine_interpreten) or (album in meine_alben)):
				
				# Werte aus und sammle
				interpretnr = -1
				if (interpret in interpreten):
					interpretnr = interpreten[interpret]
				else:
					interpretencount = interpretencount + 1
					interpretnr = interpretencount
					interpreten[interpret] = interpretencount

				albumnr = -1
				if (album in alben):
					albumnr = alben[album]
				else:
					albencount = albencount + 1
					albumnr = albencount
					alben[album] = albencount
					albenerscheinungsjahre[album] = erscheinungsjahr

				albuminterpretnr = -1
				if (compilation==''):
					if (albuminterpret in interpreten):
						albuminterpretnr = interpreten[albuminterpret]
					else:
						interpretencount = interpretencount + 1
						albuminterpretnr = interpretencount
						interpreten[albuminterpret] = interpretencount
				albeninterpreten[album] = albuminterpretnr

				# print (titel+"-"+interpret+"-"+str(interpretnr)+"-"+album+str(albumnr)+"-"+albuminterpret+"-"+str(albuminterpretnr))

				# Titel einfügen
				sql += "INSERT INTO Titel (ID, Name, Dauer, Bewertung, AlbumID, InterpretID) " 
				sql += 'VALUES('+titelid.strip()+',"'+titel.strip()+'",'+dauer+','+bewertung+','
				sql += str(albumnr)+','+str(interpretnr)+');\n'	

for interpretname in interpreten.keys():
	# Interpret einfügen
	sql += 'INSERT INTO Interpret (ID, Name) '+'VALUES('+str(interpreten[interpretname])+',"'+interpretname+'");\n'

for albumname in alben.keys():
	# Album einfügen (Albuminterpret ggf. NULL)
	verweis = 'NULL'
	if (albeninterpreten[albumname]!=-1):
		verweis = str(albeninterpreten[albumname])
	sql += 'INSERT INTO Album (ID, Name, Erscheinungsjahr, InterpretID) '
	sql += 'VALUES('+str(alben[albumname])+',"'+albumname+'",'+str(albenerscheinungsjahre[albumname])+','+verweis+');\n'

print (sql)
